///twitch_networking()

//put this script in the Asynchronous>Networking Event





//check if we are in the Asynchronous Event
if(event_number != 68){
    show_debug_message("Twitch: Networking Script have to be in the Asynchronous Event");
    return false;
}

var buff = async_load[? "buffer"];
var msg = buffer_read(buff, buffer_string);

//check if "PRIVMSG" is in msg
if(string_pos("PRIVMSG", msg)>0){
    //create map and put it in the stream
    var map = ds_map_create();
    ds_queue_enqueue(global.twitch_stream, map);
    
    var pos;
    pos = string_pos(";", msg)+1;
    //color/colour
    map[? "color"] = "";
    while(string_char_at(msg,pos++) != "="){}//search the =
    while(string_char_at(msg,pos) != ";") map[? "color"] += string_char_at(msg,pos++);
    if(map[? "color"] == "")//black is ""
        map[? "color"] = "#000000"; //set to black
    map[? "colour"] = map[? "color"];
    //displayname
    map[? "displayname"] = "";
    while(string_char_at(msg,pos) != ";") map[? "displayname"] += string_char_at(msg,pos++);
    //emotes
    map[? "emotes"] = "";
    while(string_char_at(msg,pos) != ";") map[? "emotes"] += string_char_at(msg,pos++);
    //subscriber
    map[? "subscriber"] = "";
    while(string_char_at(msg,pos++) != "="){}//search the =
    while(string_char_at(msg,pos) != ";") map[? "subscriber"] += string_char_at(msg,pos++);
    //turbo
    map[? "turbo"] = "";
    while(string_char_at(msg,pos++) != "="){}//search the =
    while(string_char_at(msg,pos) != ";") map[? "turbo"] += string_char_at(msg,pos++);
    //sender
    map[? "sender"] = "";
    while(string_char_at(msg,pos++) != ":"){}//search the :
    while(string_char_at(msg,pos) != "!") map[? "sender"] += string_char_at(msg,pos++);
    //msg
    map[? "msg"] = "";
    while(string_char_at(msg,pos++) != ":"){}//search the :
    while(pos<string_length(msg)-1){
        if(!(string_char_at(msg,pos)==chr(13) || string_char_at(msg,pos)==chr(10)))
            map[? "msg"] += string_char_at(msg,pos);
        pos ++;
    }
    
    
}
else{
    var username = global.twitch_username;
    var pos = string_pos("NOTICE * :",msg);
    if(pos>0){
        pos += 10; //length of "NOTICE * :"
        show_debug_message("Twitch: [Server] "+string_copy(msg,pos,string_length(msg)));
        return false;
    }
    if(":tmi.twitch.tv 001 "+username+" :Welcome, GLHF!"+chr(13)+chr(10) == msg){
        show_debug_message("Twitch: [Server] Welcome!");
        return true;
    }
    if(":"+username+"!"+username+"@"+username+".tmi.twitch.tv JOIN #"+global.twitch_channelname+chr(13)+chr(10) == msg){
        show_debug_message("Twitch: [Server] Joined #"+global.twitch_channelname+"!");
        return true;
    }
}

return true;

