///twitch_start(username, oauth, channelname)
//You can get the oauth here: http://twitchapps.com/tmi/


//connect to Twitch
var sock = network_create_socket(network_socket_tcp);
var connected = network_connect_raw(sock, "irc.chat.twitch.tv", 6667);
if(connected<0){
    show_debug_message("Twitch: couldn't connect");
    return connected;
}

//prepare all data
var username = string_lower(argument0);
var nickname= username;
var oauth = argument1;
var channelname = argument2;

global.twitch_channelname = channelname;
global.twitch_username = username;

var login;
login[4] = "CAP REQ :twitch.tv/tags";
login[3] = "JOIN #"+channelname;
login[2] = "NICK "+nickname;
login[1] = "USER "+username + " 0 * :" + username;
login[0] = "PASS "+oauth;

//Login

for(var i=0; i<array_length_1d(login); i++){
    var buff = buffer_create(1, buffer_grow, 1);
    buffer_seek(buff, buffer_seek_start, 0);
    buffer_write(buff, buffer_string, login[i] + chr(13)+chr(10));
    network_send_raw(sock, buff, buffer_tell(buff));
    buffer_delete(buff);
}
login = 0; //frees the array


//Create some globals
global.twitch_autoreload = false;
global.twitch_socket = sock;
global.twitch_stream = ds_queue_create();
global.twitch_http_1 = -1;
global.twitch_info = ds_map_create();
global.twitch_info[? "viewers"] = ds_list_create();
global.twitch_info[? "mods"] = ds_list_create();
global.twitch_info[? "admins"] = ds_list_create();
global.twitch_info[? "connected"] = ds_list_create();
global.twitch_info[? "disconnected"] = ds_list_create();

return true;

